%{
open B8_types

%} 

%token EOF
%token OTagB
%token CTagB
%token OTagEM
%token CTagEM
%token OTagI
%token CTagI
%token OTagPL
%token CTagPL
%token OTagS
%token CTagS
%token OTagTT
%token CTagTT
%token OTagU
%token CTagU
%token OTag0
%token CTag0
%token OTag1
%token CTag1
%token OTag2
%token CTag2
%token OTag3
%token CTag3
%token OTag4
%token CTag4
%token OTag5
%token CTag5
%token OTag6
%token CTag6
%token OTag7
%token CTag7
%token OTag8
%token CTag8
%token OTag9
%token CTag9
%token OTagr
%token CTagr
%token OTagg
%token CTagg
%token OTagb
%token CTagb
%token OTagc
%token CTagc
%token OTagm
%token CTagm
%token OTagy
%token CTagy
%token OTagk
%token CTagk
%token OTagw
%token CTagw
%token <string> TEXT

%start main
%type <B8_types.doc> main
%%

main:
  doclist EOF        { Dlist($1) }  
;

doclist:
  doc doclist        {$1::$2}
|                    {[]}
;

onedoc:
  doclist            {match $1 with [] -> Dstring("") | [d]-> d | _ -> Dlist($1)}

doc:
  
  OTagB onedoc CTagB    {  Dtag_B($2)  }
| OTagEM onedoc CTagEM  {  Dtag_EM($2) }
| OTagI onedoc CTagI    {  Dtag_I($2)  }
| OTagPL onedoc CTagPL  {  Dtag_PL($2) }
| OTagS onedoc CTagS    {  Dtag_S($2)  }
| OTagTT onedoc CTagTT  {  Dtag_TT($2) }
| OTagU onedoc CTagU    {  Dtag_U($2)  }
| OTag0 onedoc CTag0    {  Dtag_size($2,T0)}
| OTag1 onedoc CTag1    {  Dtag_size($2,T1)}
| OTag2 onedoc CTag2    {  Dtag_size($2,T2)}
| OTag3 onedoc CTag3    {  Dtag_size($2,T3)}
| OTag4 onedoc CTag4    {  Dtag_size($2,T4)}
| OTag5 onedoc CTag5    {  Dtag_size($2,T5)}
| OTag6 onedoc CTag6    {  Dtag_size($2,T6)}
| OTag7 onedoc CTag7    {  Dtag_size($2,T7)}
| OTag8 onedoc CTag8    {  Dtag_size($2,T8)}
| OTag9 onedoc CTag9    {  Dtag_size($2,T9)}
| OTagr onedoc CTagr    {  Dtag_color($2,Red)}
| OTagg onedoc CTagg    {  Dtag_color($2,Green)}
| OTagb onedoc CTagb    {  Dtag_color($2,Blue)}
| OTagc onedoc CTagc    {  Dtag_color($2,Cyan)}
| OTagm onedoc CTagm    {  Dtag_color($2,Magenta)}
| OTagy onedoc CTagy    {  Dtag_color($2,Yellow)}
| OTagk onedoc CTagk    {  Dtag_color($2,Black)}
| OTagw onedoc CTagw    {  Dtag_color($2,White)}
| TEXT                   {  Dstring($1)}
